{-# LANGUAGE RecordWildCards #-}

{-# LANGUAGE NoImplicitPrelude #-}

module Datarekisteri.Backend.DB where

import Relude

import Datarekisteri.Backend.Types
import Datarekisteri.Core.Types

dbGetUserEmail :: MonadDB m => UserID -> m (DBEither (Maybe Email))
dbGetUserEmail userID = do
    userOrErr <- dbGetUser userID
    case userOrErr of
      Left err -> pure $ Left err
      Right DBUser {..} -> Right <$> dbUserEmail

dbGetUserPendingEmail :: MonadDB m => UserID -> m (DBEither (Maybe Email))
dbGetUserPendingEmail userID = do
    userOrErr <- dbGetUser userID
    case userOrErr of
      Left err -> pure $ Left err
      Right DBUser {..} -> Right <$> dbUserPendingEmail
