{-# LANGUAGE OverloadedStrings #-}

module Datarekisteri.Backend.Email where

import Data.Text (Text)
import Data.Text.Lazy (fromStrict)
import Network.Mail.Mime (Address(..), simpleMail')

import Datarekisteri.Backend.Types
import Datarekisteri.Core.Types

sendDatarekisteriEmail :: MonadEmail m => Text -> Text -> Email -> m ()
sendDatarekisteriEmail subject content to = do
    from <- fromAddress
    sendEmail $ simpleMail' (Address Nothing $ renderEmail to) from subject $ fromStrict content

sendVerificationEmail :: MonadEmail m => Text -> Email -> m ()
sendVerificationEmail secret = sendDatarekisteriEmail "Sähköpostin vahvistuskoodi" $
        "Vahvista sähköpostisi syöttämällä alla oleva koodi rekisteriin:\n\n"
        <> secret <> "\n\n"
        <> "Mikäli et odottanut tätä viestiä, voit jättää sen turvallisesti huomiotta."

sendApplicationAcceptedEmail :: MonadEmail m => Email -> m ()
sendApplicationAcceptedEmail = sendDatarekisteriEmail "Jäsenhakemus hyväksytty" $
        "Jäsenhakemuksesi Datat RY:lle on hyväksytty. Olet nyt yhdistyksen jäsen."

sendApplicationRejectedEmail :: MonadEmail m => Email -> m ()
sendApplicationRejectedEmail = sendDatarekisteriEmail "Jäsenhakemus hylätty" $
        "Jäsenhakemuksesi Datat RY:lle on hylätty. Voit halutessasi kysyä hakemuksen"
        <> " hylkäämisen syistä yhdistyksen hallitukselta <hallitus@datat.fi>."
